org.eclipse.modisco.java.composition.discoverer

## Class AbstractDiscoverKDMSourceAndJavaModel<T>

- java.lang.Object
- - org.eclipse.modisco.infra.discovery.core.AbstractDiscoverer<T>
  - - org.eclipse.modisco.infra.discovery.core.AbstractModelDiscoverer<T>
    - - org.eclipse.modisco.kdm.source.extension.discovery.AbstractComposedKDMSourceDiscoverer2<T>
      - - org.eclipse.modisco.java.composition.discoverer.AbstractDiscoverKDMSourceAndJavaModel<T>

All Implemented Interfaces:
  IDiscoverer<T>

Direct Known Subclasses:
  DiscoverKDMSourceAndJavaModelFromJavaProject, DiscoverKDMSourceAndJavaModelFromProject

    public abstract class AbstractDiscoverKDMSourceAndJavaModel<T>
    extends AbstractComposedKDMSourceDiscoverer2<T>

This Class provides a way of weaving a MoDisco Java model with a MoDisco KDM Source model. Both models are discovered independently and then read to weave some instances like Archive, Compilation Unit ... See Help contents or http://wiki.eclipse.org/MoDisco/Components/Java/Composition

### Constructor Summary

Constructors
Constructor and Description
`AbstractDiscoverKDMSourceAndJavaModel()`

### Method Summary

All Methods Instance Methods Concrete Methods
`java.util.Map<CompilationUnit,java.util.List<JavaNodeSourceRegion>>` `getCuToRegionsMap()`
`Resource` `getJavaAppModelResource()`
`Model` `getJavaModel()`
`Resource` `getJavaModelResource()`
`Segment` `getKdmModel()`
`Resource` `getKdmSourceModelResource()`
`Resource` `getPackage2DirectoryResource()`
`void` `setDeepAnalysis(boolean deepAnalysis)`
`void` `setElementsToAnalyze(ElementsToAnalyze elementsToAnalyze)`
`void` `setExcludedElementsRegEx(java.lang.String excludedElementsRegEx)`
`void` `setIncludedElementsRegEx(java.lang.String includedElementsRegEx)`
`void` `setIncrementalMode(boolean incrementalMode)`
`void` `setLogJavaAnalysisWarnings(boolean logJavaAnalysisWarnings)`

### Methods inherited from class org.eclipse.modisco.infra.discovery.core.AbstractModelDiscoverer

`discoverElement, getDefaultTargetURI, getTargetModel, getTargetURI, setSerializeTarget, setTargetModel, setTargetURI`

### Methods inherited from class org.eclipse.modisco.infra.discovery.core.AbstractDiscoverer

`isAFolder, isAJavaProject, isAnIFileWithExtension, isAProject, setRefreshSourceBeforeDiscovery`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.modisco.infra.discovery.core.IDiscoverer

`isApplicableTo`

### Constructor Detail

#### AbstractDiscoverKDMSourceAndJavaModel

    public AbstractDiscoverKDMSourceAndJavaModel()

### Method Detail

#### setElementsToAnalyze

    @Parameter(name="ELEMENTS_TO_ANALYZE",
               description="The Java projects or packages that will be analyzed.")
    public void setElementsToAnalyze(ElementsToAnalyze elementsToAnalyze)

#### setLogJavaAnalysisWarnings

    @Parameter(name="LOG_JAVA_ANALYSIS_WARNINGS",
               description="Whether to log warnings from java analysis.")
    public void setLogJavaAnalysisWarnings(boolean logJavaAnalysisWarnings)

#### setDeepAnalysis

    @Parameter(name="DEEP_ANALYSIS",
               description="If true, analyze method bodies. If false, only analyze fields and method signatures.")
    public void setDeepAnalysis(boolean deepAnalysis)

#### setIncrementalMode

    @Parameter(name="INCREMENTAL_MODE",
               description="Optimize memory use by analyzing incrementally (more time expensive).")
    public void setIncrementalMode(boolean incrementalMode)

#### setIncludedElementsRegEx

    @Parameter(name="INCLUDED_ELEMENTS_REGEX",
               description="A regular expression on qualified names for elements (types & packages) to be included during analysis")
    public void setIncludedElementsRegEx(java.lang.String includedElementsRegEx)

#### setExcludedElementsRegEx

    @Parameter(name="EXCLUDED_ELEMENTS_REGEX",
               description="A regular expression on qualified names for elements (types & packages) to be excluded during analysis")
    public void setExcludedElementsRegEx(java.lang.String excludedElementsRegEx)

#### getJavaModel

    public Model getJavaModel()

#### getKdmModel

    public Segment getKdmModel()

#### getKdmSourceModelResource

    public Resource getKdmSourceModelResource()

#### getPackage2DirectoryResource

    public Resource getPackage2DirectoryResource()

#### getJavaAppModelResource

    public Resource getJavaAppModelResource()

#### getCuToRegionsMap

    public java.util.Map<CompilationUnit,java.util.List<JavaNodeSourceRegion>> getCuToRegionsMap()

#### getJavaModelResource

    public Resource getJavaModelResource()